/* PLOT.PRG */

/* This program produces the graphs shown in
"Testing for Linearity" by Bruce E. Hansen.
For updates and contact information, see my webpage
www.ssc.wisc.edu/~bhansen
*/

load sun_k1,sun_k2,sun_k3;
load ip_k1,ip_k2,ip_k3;

rt =0; 		@ to rotate graphs and create .eps files @

load ss[]=sunspot.dat;
ss=(sqrt(1+ss)-1)*2;
n=rows(ss);
xs=seqa(1988-n,1,n);
graphset;
title("Figure 1: Annual Sunspot Means, 1700-1988");
if rt==1; 
  _protate=1; 
  graphprt("-c=1");
endif;
_pdate="";
_pcolor=15;
_plwidth=3;
xy(xs,ss);

load ip[]=ip.dat;
ip=ln(ip);
ip=(ip[13:rows(ip)]-ip[1:rows(ip)-12])*100;
ip=ip[157:rows(ip)];
xp=seqa(1960,1/12,rows(ip));
graphset;
  title("Figure 2: U.S. Monthly Industrial Production\LAnnual Growth, 1960-1998");
if rt==1; 
  _protate=1; 
  graphprt("-c=1");
else;
endif;
_pdate="";
_pcolor=15;
_plwidth=3;
xy(xp,ip);

graphset;
_pdate="";
_pcolor=15;
_plwidth=3;
xtics(0,80,10,2);
let _pltype = 6 1 4 3 2;
title("Figure 3: Sunspot Series\LAsymptotic and Bootstrap Distributions of F]12[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 5 4.5;
endif;
_plegstr="Chi-Square(k)";
_plegstr=_plegstr $+ "\000Asymptotic (Homo.)";
_plegstr=_plegstr $+ "\000Bootstrap (Homo.)";
_plegstr=_plegstr $+ "\000Asymptotic (Hetero.)";
_plegstr=_plegstr $+ "\000Bootstrap (Hetero.)";
xlabel("Bootstrap Distributions of F]12[");
xy(sun_k1[.,1],sun_k1[.,2 3 4 5 6]);

graphset;
_pdate="";
_pcolor=15;
_plwidth=3;
xtics(0,80,10,2);
let _pltype = 6 1 4 3 2;
title("Figure 4: Industrial Production\LAsymptotic and Bootstrap Distributions of F]12[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 5 4.5;
endif;
_plegstr="Chi-Square(k)";
_plegstr=_plegstr $+ "\000Asymptotic (Homo.)";
_plegstr=_plegstr $+ "\000Bootstrap (Homo.)";
_plegstr=_plegstr $+ "\000Asymptotic (Hetero.)";
_plegstr=_plegstr $+ "\000Bootstrap (Hetero.)";
xlabel("Bootstrap Distributions of F]12[");
xy(ip_k1[.,1],ip_k1[.,2 3 4 5 6]);


graphset;
xtics(0,120,20,4);
_pdate="";
_pcolor=15;
_plwidth=3;
let _pltype = 6 3 4;
title("Figure 5: Sunspot Series\LAsymptotic and Bootstrap Distributions of F]13[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 6 5;
endif;
_plegstr="Chi-Square(2k)\000Bootstrap (Homo.)\000Bootstrap (Hetero.)";
xy(sun_k2[.,1],sun_k2[.,2 3 4]);


graphset;
_pdate="";
_pcolor=15;
_plwidth=3;
let _pltype = 6 3 4;
title("Figure 6: Industrial Production\LAsymptotic and Bootstrap Distributions of F]13[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 6 5;
endif;
_plegstr="Chi-Square(2k)\000Bootstrap (Homo.)\000Bootstrap (Hetero.)";
xy(ip_k2[.,1],ip_k2[.,2 3 4]);


graphset;
_pdate="";
_pcolor=15;
_plwidth=3;
let _pltype = 6 1 4 3 2;
title("Figure 7: Sunspot Series\LAsymptotic and Bootstrap Distributions of F]23[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 5 4.5;
endif;
_plegstr="Chi-Square(k)";
_plegstr=_plegstr $+ "\000Homoskedastic";
_plegstr=_plegstr $+ "\000Regime Hetero.";
_plegstr=_plegstr $+ "\000General Hetero.";
xlabel("Bootstrap Distributions of F]23[");
xy(sun_k3[.,1],sun_k3[.,2 3 4 5]);

graphset;
_pdate="";
_pcolor=15;
_plwidth=3;
xtics(0,70,10,2);
let _pltype = 6 1 4 3 2;
title("Figure 8: Industrial Production\LAsymptotic and Bootstrap Distributions of F]13[");
if rt==1; 
  _protate=1; 
  let _plegctl[1,4]= 2 5 3.7 6.2;
  graphprt("-c=1");
else;
  let _plegctl[1,4]= 2 5 5 4.5;
endif;
_plegstr="Chi-Square(k)";
_plegstr=_plegstr $+ "\000Homoskedastic";
_plegstr=_plegstr $+ "\000Regime Hetero.";
_plegstr=_plegstr $+ "\000General Hetero.";
xlabel("Bootstrap Distributions of F]23[");
xy(ip_k3[.,1],ip_k3[.,2 3 4 5]);
